// TTFFileViewerDlg.cpp : implementation file
//

#include "stdafx.h"
#include "TTFFileViewer.h"
#include "TTFFileViewerDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef struct _tagTT_OFFSET_TABLE{
	USHORT	uMajorVersion;
	USHORT	uMinorVersion;
	USHORT	uNumOfTables;
	USHORT	uSearchRange;
	USHORT	uEntrySelector;
	USHORT	uRangeShift;
}TT_OFFSET_TABLE;

typedef struct _tagTT_TABLE_DIRECTORY{
	char	szTag[4];			//table name
	ULONG	uCheckSum;			//Check sum
	ULONG	uOffset;			//Offset from beginning of file
	ULONG	uLength;			//length of the table in bytes
}TT_TABLE_DIRECTORY;

typedef struct _tagTT_NAME_TABLE_HEADER{
	USHORT	uFSelector;			//format selector. Always 0
	USHORT	uNRCount;			//Name Records count
	USHORT	uStorageOffset;		//Offset for strings storage, from start of the table
}TT_NAME_TABLE_HEADER;

typedef struct _tagTT_NAME_RECORD{
	USHORT	uPlatformID;
	USHORT	uEncodingID;
	USHORT	uLanguageID;
	USHORT	uNameID;
	USHORT	uStringLength;
	USHORT	uStringOffset;	//from start of storage area
}TT_NAME_RECORD;

#define SWAPWORD(x)		MAKEWORD(HIBYTE(x), LOBYTE(x))
#define SWAPLONG(x)		MAKELONG(SWAPWORD(HIWORD(x)), SWAPWORD(LOWORD(x)))


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTTFFileViewerDlg dialog

CTTFFileViewerDlg::CTTFFileViewerDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTTFFileViewerDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CTTFFileViewerDlg)
	m_csName = _T("");
	m_csCopyright = _T("");
	m_csTrademark = _T("");
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTTFFileViewerDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTTFFileViewerDlg)
	DDX_Control(pDX, IDC_LFONTS, m_wndFontsList);
	DDX_Control(pDX, IDC_SURL, m_wndUrl);
	DDX_Text(pDX, IDC_ENAME, m_csName);
	DDX_Text(pDX, IDC_SCOPYRIGHT, m_csCopyright);
	DDX_Text(pDX, IDC_STRADEMARK, m_csTrademark);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CTTFFileViewerDlg, CDialog)
//{{AFX_MSG_MAP(CTTFFileViewerDlg)
ON_WM_SYSCOMMAND()
ON_WM_PAINT()
ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BOPEN, OnBopen)
	ON_LBN_SELCHANGE(IDC_LFONTS, OnSelchangeLfonts)
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTTFFileViewerDlg message handlers

BOOL CTTFFileViewerDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	m_wndUrl.SetURL("http://www.stpworks.com");
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTTFFileViewerDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CTTFFileViewerDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

HCURSOR CTTFFileViewerDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


void CTTFFileViewerDlg::OnBopen() 
{
	BROWSEINFO bi;	
	ZeroMemory(&bi, sizeof(BROWSEINFO));
	TCHAR szDiplayName[MAX_PATH];
	ZeroMemory(szDiplayName, MAX_PATH);
	LPITEMIDLIST lpStartFolder = NULL;
	SHGetSpecialFolderLocation(GetSafeHwnd(), CSIDL_DRIVES, &lpStartFolder);
	bi.hwndOwner = GetSafeHwnd();
	bi.pszDisplayName = szDiplayName;
	bi.lpszTitle = _T("Choose a folder containing TTF fonts");
	bi.ulFlags = BIF_USENEWUI|BIF_NONEWFOLDERBUTTON;
	bi.pidlRoot = lpStartFolder;
	LPITEMIDLIST pIDList = SHBrowseForFolder(&bi);
	LPMALLOC pMalloc = NULL;
	SHGetMalloc(&pMalloc);
	if(pIDList != NULL){
		SHGetPathFromIDList(pIDList, m_csLocation.GetBuffer(MAX_PATH));	
		m_csLocation.ReleaseBuffer();
		pMalloc->Free(pIDList);
		if(m_csLocation.GetLength() > 0 && m_csLocation[m_csLocation.GetLength()-1] != TCHAR('\\'))
			m_csLocation += "\\";
	}
	pMalloc->Free(lpStartFolder);	pMalloc->Release();
	
	if(!m_csLocation.IsEmpty()){
		CWaitCursor wait;
		
		//remove all fonts from list first
		for(int i=0; i<m_wndFontsList.GetCount(); i++){
			LPFONT_PROPERTIES lpFontProps = (LPFONT_PROPERTIES)m_wndFontsList.GetItemDataPtr(i);
			if(lpFontProps != NULL){
				delete lpFontProps;
				lpFontProps = NULL;
			}
		}
		m_wndFontsList.ResetContent();

		CFileFind ff;
		int nIndex;
		
		
		BOOL bWorking = ff.FindFile(m_csLocation + "*.ttf");
		while(bWorking){
			bWorking = ff.FindNextFile();
			LPFONT_PROPERTIES lpFontProps = new FONT_PROPERTIES;
			if(GetFontProperties(ff.GetFilePath(), lpFontProps)){
				nIndex = m_wndFontsList.AddString(lpFontProps->csName);
				m_wndFontsList.SetItemDataPtr(nIndex, lpFontProps);
			}else{
				delete lpFontProps;
			}
		}

		ff.Close();
	}

}

BOOL CTTFFileViewerDlg::GetFontProperties(LPCTSTR lpszFilePath, LPFONT_PROPERTIES lpFontProps)
{
	CFile f;
	BOOL bRetVal = FALSE;

	if(f.Open(lpszFilePath, CFile::modeRead|CFile::shareDenyWrite)){
		TT_OFFSET_TABLE ttOffsetTable;
		f.Read(&ttOffsetTable, sizeof(TT_OFFSET_TABLE));
		ttOffsetTable.uNumOfTables = SWAPWORD(ttOffsetTable.uNumOfTables);
		ttOffsetTable.uMajorVersion = SWAPWORD(ttOffsetTable.uMajorVersion);
		ttOffsetTable.uMinorVersion = SWAPWORD(ttOffsetTable.uMinorVersion);

		//check is this is a true type font and the version is 1.0
		if(ttOffsetTable.uMajorVersion != 1 || ttOffsetTable.uMinorVersion != 0)
			return bRetVal;
		
		TT_TABLE_DIRECTORY tblDir;
		BOOL bFound = FALSE;
		CString csTemp;
		
		for(int i=0; i< ttOffsetTable.uNumOfTables; i++){
			f.Read(&tblDir, sizeof(TT_TABLE_DIRECTORY));
			strncpy(csTemp.GetBuffer(5), tblDir.szTag, 4);
			csTemp.ReleaseBuffer(4);
			if(csTemp.CompareNoCase(_T("name")) == 0){
				bFound = TRUE;
				tblDir.uLength = SWAPLONG(tblDir.uLength);
				tblDir.uOffset = SWAPLONG(tblDir.uOffset);
				break;
			}else if(csTemp.IsEmpty()){
				break;
			}
		}
		
		if(bFound){
			f.Seek(tblDir.uOffset, CFile::begin);
			TT_NAME_TABLE_HEADER ttNTHeader;
			f.Read(&ttNTHeader, sizeof(TT_NAME_TABLE_HEADER));
			ttNTHeader.uNRCount = SWAPWORD(ttNTHeader.uNRCount);
			ttNTHeader.uStorageOffset = SWAPWORD(ttNTHeader.uStorageOffset);
			TT_NAME_RECORD ttRecord;
			bFound = FALSE;
			
			for(int i=0; 
				i<ttNTHeader.uNRCount && 
					(lpFontProps->csCopyright.IsEmpty() || lpFontProps->csName.IsEmpty() || lpFontProps->csTrademark.IsEmpty() || lpFontProps->csFamily.IsEmpty()); 
				i++){
				f.Read(&ttRecord, sizeof(TT_NAME_RECORD));
				ttRecord.uNameID = SWAPWORD(ttRecord.uNameID);
				ttRecord.uStringLength = SWAPWORD(ttRecord.uStringLength);
				ttRecord.uStringOffset = SWAPWORD(ttRecord.uStringOffset);

				if(ttRecord.uNameID == 1 || ttRecord.uNameID == 0 || ttRecord.uNameID == 7){
					int nPos = f.GetPosition();
					f.Seek(tblDir.uOffset + ttRecord.uStringOffset + ttNTHeader.uStorageOffset, CFile::begin);
					csTemp.Empty();
					f.Read(csTemp.GetBuffer(ttRecord.uStringLength), ttRecord.uStringLength);
					csTemp.ReleaseBuffer();
					if(csTemp.GetLength() > 0){
						switch(ttRecord.uNameID){
						case 1:
							lpFontProps->csFamily.IsEmpty() ? lpFontProps->csFamily = csTemp : void(0);
							bRetVal = TRUE;
							break;
						case 0:
							lpFontProps->csCopyright.IsEmpty() ? lpFontProps->csCopyright = csTemp : void(0);
							break;
						case 7:
							lpFontProps->csTrademark.IsEmpty() ? lpFontProps->csTrademark = csTemp : void(0);
							break;
						case 4:
							lpFontProps->csName.IsEmpty() ? lpFontProps->csName = csTemp : void(0);
							break;
						default:
							break;
						}
					}
					f.Seek(nPos, CFile::begin);
				}
			}			
		}
		f.Close();
		if(lpFontProps->csName.IsEmpty())
			lpFontProps->csName = lpFontProps->csFamily;
	}
	return bRetVal;
	
}

void CTTFFileViewerDlg::OnSelchangeLfonts() 
{
	LPFONT_PROPERTIES lpFontProps = (LPFONT_PROPERTIES)m_wndFontsList.GetItemDataPtr(m_wndFontsList.GetCurSel());
	if(lpFontProps != NULL){
		m_csCopyright = lpFontProps->csCopyright;
		m_csName = lpFontProps->csFamily;
		m_csTrademark = lpFontProps->csTrademark;
	}else{
		m_csCopyright.Empty();
		m_csName.Empty();
		m_csTrademark.Empty();
	}
	UpdateData(FALSE);
}

void CTTFFileViewerDlg::OnDestroy() 
{
	CWaitCursor wait;
	for(int i=0; i<m_wndFontsList.GetCount(); i++){
		LPFONT_PROPERTIES lpFontProps = (LPFONT_PROPERTIES)m_wndFontsList.GetItemDataPtr(i);
		if(lpFontProps != NULL){
			delete lpFontProps;
			lpFontProps = NULL;
		}
	}
	
	
	CDialog::OnDestroy();
	

}
